//+------------------------------------------------------------------+
//|                                                   ModifyFibo.mq4 |
//|                              Vladislav Shurkin, 3  2013 . |
//|    "Fibo"   -|
//|:       ,   |
//|  ,       |
//|,   /   - |
//|,         ..      |
//+------------------------------------------------------------------+
#property copyright "Vladislav Shurkin, 3  2013 ."
#property link      "vlad-755@mail.ru"
#property show_inputs
//+------------------------------------------------------------------+
//| .                                         |
//+------------------------------------------------------------------+
/*
        (100  0) -
  Fibo.      ' -
'  .

1000=10:
 - 100 -       100;
 - 0 -       0;
 - 10 ( ) -   .
 
100=0 -  100     
   (    ,
 - , 0 ( ) -   .

0=0 -  0     -
   (    ,
 - , 0 ( ) -   .

12 -     
         -
:
 - 1 -   ;
 - 2 -   ;
 - 12 -     ;
 - 0 ( ) -   .
 
=0.0 -     ,
    .

=10.0 -   /  ,
    (   0.0  1.0).
        .

10=10:
 - 1 -     ;
 - 0 -      ;
 - 10 ( ) -   .

:       
 ,          Fibo,
     ,    
        .

       
  (  ).   
   ShCuZ  true   .
  ShCuZ   .

       Fibo   "
"     ,   
      SortLev  false
  . 

      ,   
   .

         .
       "".

       
    ,      
     .
*/
//+------------------------------------------------------------------+
//|  (    )           |
//+------------------------------------------------------------------+
extern int 1000=10;//  
extern int 100=0;//  100    
extern int 0=0;//  0    
extern int 12;//  
extern double =0.0;//   
extern double =10.0;//    
extern int 10=10;///  
extern string ="";//    
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
bool ShCuZ=false;//     (false/true)
bool SortLev=true;//  (false/true)
//----
int VrtPnt;//  
int MvPnt100;//  100    
int MvPnt0;//  0    
int SvFstP;//  
double AddLev;//   
double LevLn;//    
bool ShPr;///  
bool ObByNm;//    
//----
bool Vsb;//     
int StartMoment;//  
int n;// (),  
int z;// 
int u,j,i;// 
int CntFb;//  Fibo
int CntL;//   Fibo
int Err;// 
int ObjT;//    
int Prd;//      
int Shift;// ,    
int AsTm[7]={1,2,3,4,5,6,7};// 
int AsPr[7]={1,3,5,15,30,55,90};// 
double PrOD;//     
double Pr100;//    100  Fibo
double Pr0;//    0  Fibo
double m;// , 
double LevLnS;//  
double PrLevLn;//    LevLn
double MnL[32];//   Fibo, %
double PrN;//   N  Fibo
datetime TmOD;//     
datetime Tm100,Tm100p;//    100%  Fibo
datetime Tm0,Tm0p;//    0%  Fibo
datetime TmLn1,TmLn2;//    1  2  NmLn
datetime TmLnS;//  
string Txt,Txt1,Txt2;//Txt
string TxtExNm;// 
string Name,NameM;//  Fibo
string NmLn;//    
color Clr;// 
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//====0========================================================+
   StartMoment=GetTickCount();//  
   Print(" ",WindowExpertName(),"     ",Symbol(),
   " ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));//
//====1= ====================================+
   VrtPnt=1000;//
   MvPnt100=100;//  100    
   MvPnt0=0;//  0    
   SvFstP=12;//  
   AddLev=;//   
   LevLn=;//    
   ShPr=10;///  
   TmOD=WindowTimeOnDropped();//     
   PrOD=WindowPriceOnDropped();//     
   ObjT=ObjectsTotal();//       
   Prd=Period();//      
   TxtExNm=WindowExpertName();// 
   if(!="")ObByNm=true;//   
   if(ObByNm==true)NameM=;//  Fibo
//====2=   ====================+
//----2-1-     -----------------------+
   if(TmOD==0 && PrOD==0 && ObByNm==false)//  0
   {
   Txt=StringConcatenate("    .\n   ",
   "          ",
   " 'Fibo' (0  100).");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//  
   return(0);//   , =0
   }// if(TmOD==0 && PrOD==0)
//----2-2-   -----------------------------+
   if(VrtPnt==10 && MvPnt0==0 && MvPnt100==0 && SvFstP==0&& AddLev==0
   && LevLn==10 && ShPr==10)//    ' '
   {
   Txt=StringConcatenate("  ",TxtExNm,"  . ",
   "\n    ' '.");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// if(VrtPnt==10 ...
//----2-3-    VrtPnt--------------+
   if(VrtPnt==0 || VrtPnt==10 || VrtPnt==100)z=0;//z- 
   else
   {
   Txt=StringConcatenate("  '1000'  ",
   VrtPnt,"  . \n   : 0, 10, 100. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// else
//----2-4-    SvFstP--------------+
   if(SvFstP==0 || SvFstP==1 || SvFstP==2 || SvFstP==12)z=0;//z- 
   else
   {
   Txt=StringConcatenate("  '12'  ",
   SvFstP,"  . \n   : 0, 1, 2, 12. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// else   
//----2-5-     Fibo-+
   if(AddLev>10)// Fibo- > 10
   {
   Txt=StringConcatenate("   Fibo- > 10. ",
   "\n","   : ",
   "\n0.118, 0.786, 1.118, 1.272, 1.382, 1.764, 1.882  .. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// if(AddLev>10)
//----2-6-       +
   if(LevLn>10)//  > 10
   {
   Txt=StringConcatenate("      > 10. ",
   "\n","   Fibo-: ",
   "\n0.118, 0.786, 1.118, 1.272, 1.382, 1.764, 1.882  .. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// if(AddLev>10)
//----2-7-    ShPr----------------+
   if(ShPr==0 || ShPr==1 || ShPr==10)z=0;//z- 
   else
   {
   Txt=StringConcatenate("  '10'  ",
   ShPr,"  . \n   : 0, 1, 10. ",
   "\n  .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//
   return(0);//   , =0
   }// else   
//====3=  ==============================+
   if(ObByNm==false)//   
   {
//----3-1-     ----------------+
   if(ShCuZ==true)//
    {
   ObjectCreate("SpModFibo",OBJ_ELLIPSE,0,TmOD-Prd*60,PrOD,TmOD+Prd*60,PrOD);//
   Err=GetLastError();// 
   if(Err>0 && Err!=4200)Print("#31-ErrCreateELLIPSE=",Err);// 
   if(Err==4200)//  
     {
   if(ObjectDelete("SpModFibo")!=true)//  SpModFibo
   Print("#31-ErrObjectDelete=",GetLastError());// 
   if(ObjectCreate("SpModFibo",OBJ_ELLIPSE,0,TmOD-Prd*60,PrOD,TmOD+Prd*60,PrOD)!=true)//
   Print("#31-ErrCreateELLIPSE=",GetLastError());// 
     }// if(Err==4200)
   if(ObjectSet("SpModFibo",OBJPROP_COLOR,Red)!=true)//   
   Print("#31-ErrSetCOLOR=",GetLastError());// 
   if(ObjectSet("SpModFibo",OBJPROP_SCALE,1)!=true)//   
   Print("#31-ErrSetSCALE=",GetLastError());// 
   if(ObjectSet("SpModFibo",OBJPROP_BACK,0)!=true)//   
   Print("#31-ErrSetBACK=",GetLastError());// 
   if(ObjectSet("SpModFibo",OBJPROP_WIDTH,5)!=true)//   
   Print("#31-ErrSetWIDTH=",GetLastError());// 
   ObjectSetText("SpModFibo","  ",10,"Arial",CLR_NONE);//
   Err=GetLastError();if(Err>0)Print("ObjectSetTextCP=",Err);// 
   WindowRedraw();//   
   Print("  : Tm=",
   TimeToStr(TmOD,TIME_DATE|TIME_MINUTES),", Pr=",PrOD);//
    }// if(ShCuZ==true)
//----3-2-   -----------------------------+
   for(u=0;u<7;)// u
    {
   if(CntFb>0)break;// ,    u
   for(j=0;j<7;)// j
     {
   if(CntFb>0)break;// ,    j
   n=AsTm[u];//  
   if(Digits==3 || Digits==5)m=AsPr[j]*Point*10;//  
   else m=AsPr[j]*Point;//  
//----3-3-     -----------------+
   if(ShCuZ==true)//
    {
   ObjectCreate("RaModFibo",OBJ_RECTANGLE,0,TmOD-n*Prd*60,PrOD-m,
   TmOD+n*Prd*60,PrOD+m);//
   Err=GetLastError();// 
   if(Err>0 && Err!=4200)Print("#33-ErrObjectCreateRa=",Err);// 
   if(Err==4200)//  
     {
   if(ObjectDelete("RaModFibo")!=true)//  "RaModFibo"
   Print("#33-ErrObjectDeleteRa=",GetLastError());// 
   if(ObjectCreate("RaModFibo",OBJ_RECTANGLE,0,TmOD-n*Prd*60,PrOD-m,
   TmOD+n*Prd*60,PrOD+m)!=true)//
   Print("#33-ErrObjectCreateRa=",GetLastError());// 
     }// if(Err==4200)
   if(ObjectSet("RaModFibo",OBJPROP_COLOR,Yellow)!=true)//   
   Print("#33-ErrSetCOLOR=",GetLastError());// 
   if(ObjectSet("RaModFibo",OBJPROP_BACK,0)!=true)//   
   Print("#33-ErrSetBACK=",GetLastError());// 
   WindowRedraw();//   
   Sleep(1500);//
    }// if(ShCuZ==true)
//----3-4-  ------------------------------+
   for(i=0;i<ObjT;i++)//   
     {
   Name=ObjectName(i);// 
   Err=GetLastError();if(Err>0)Print("#34-",i,"-ErrObjectName=",Err);// 
   if(ObjectType(Name)!=OBJ_FIBO)//  ...
      {
   Err=GetLastError();if(Err>0)Print("#34-",i,"-ObjectType=",Err);// 
   continue;//...
      }
   Tm100=ObjectGet(Name,OBJPROP_TIME1);//   ( 100)
   Err=GetLastError();if(Err>0)Print("#34-",i,"-ErrTIME1=",Err);// 
   Pr100=ObjectGet(Name,OBJPROP_PRICE1);//   ( 100)
   Err=GetLastError();if(Err>0)Print("#34-",i,"-ErrPRICE1=",Err);// 
   Tm0=ObjectGet(Name,OBJPROP_TIME2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#34-",i,"-ErrTIME2=",Err);//    
   Pr0=ObjectGet(Name,OBJPROP_PRICE2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#34-",i,"-ErrPRICE2=",Err);// 
//----3-5-  ----------------------------------+
   if((Tm100<TmOD+n*Prd*60 && Tm100>TmOD-n*Prd*60) 
   || (Tm0<TmOD+n*Prd*60 && Tm0>TmOD-n*Prd*60) && (Pr100<PrOD+m && Pr100>PrOD-m) 
   || (Pr0<PrOD+m && Pr0>PrOD-m))//
       {
   NameM=Name;//   Fibo
   CntFb++;//  Fibo
   Vsb=ObjectGet(NameM,OBJPROP_TIMEFRAMES);//  
   Err=GetLastError();if(Err>0)Print("#25-",i,"-ErrTIMEFRAMES=",Err);//    
   if(Vsb==0)//   
        {
   Print("  ",i," - ",NameM);//
   Print("   ",NameM,
   ": Tm100=",TimeToStr(Tm100,TIME_DATE|TIME_MINUTES)," Pr100=",Pr100,
   " Tm0=",TimeToStr(Tm0,TIME_DATE|TIME_MINUTES)," Pr0=",Pr0);//
        }
   else 
        {
   Print("  ",i," - ",NameM," (   )");//
   Print(" ",NameM,": Tm100=",TimeToStr(Tm100,TIME_DATE|TIME_MINUTES),
   " Pr100=",Pr100," Tm0=",TimeToStr(Tm0,TIME_DATE|TIME_MINUTES)," Pr0=",Pr0);//
        }
       }// if((Tm100<TmOD+Prd*60 && Tm100>TmOD-Prd*60))...
      }// for(i=0;i<ObjT;i++)
   u++;// u
   j++;// j
     }// for(j=0;j<7;)
    }// for(u=0;u<7;)
   if(ShCuZ==true)//   
    {
   ObjectSetText("RaModFibo","  ",10,"Arial",CLR_NONE);// 
   Err=GetLastError();if(Err>0)Print("ObjectSetTextRa=",Err);// 
    }// if(ShCuZ==true)
//----3-6-      Fibo------------------+
   if(CntFb==0)//  Fibo
    {
   Txt1=StringConcatenate("   ",
   TimeToStr(TmOD-n*Prd*60,TIME_DATE|TIME_MINUTES),
   " - ",TimeToStr(TmOD+n*Prd*60,TIME_DATE|TIME_MINUTES),"   ",PrOD-m,
   " - ",PrOD+m,"    'Fibo' .");//Txt1
   Txt2=StringConcatenate("\n      ",
   "        'Fibo' (0  100).");//Txt2
   Txt=StringConcatenate(Txt1,Txt2);//Txt
   PlaySound("Inform.wav");// 
   Print(Txt1);Print(Txt2);//
   MessageBox(Txt,TxtExNm);//
    }// if(CntFb==0)
//----3-7-      Fibo-----------+
   if(CntFb>1)//        Fibo
    {
   Txt=StringConcatenate("   ",
   TimeToStr(TmOD-n*Prd*60,TIME_DATE|TIME_MINUTES),
   " - ",TimeToStr(TmOD+n*Prd*60,TIME_DATE|TIME_MINUTES),
   "   ",PrOD-m," - ",PrOD+m,"   ",CntFb,
   "-  'Fibo'. ","\n    . ",
   "\n     .");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//  
    }// if(CntFb>1)
   }// if(ObByNm==false)
//====4=  ===============================+
   if(CntFb==1 || ObByNm==true)//   Fibo    
    {
//----4-1-  ------------------------------+
   Tm100=ObjectGet(NameM,OBJPROP_TIME1);//   ( 100)
   Err=GetLastError();// 
   if(Err==4202)
     {
   Txt=StringConcatenate("   ",NameM,"   ",Symbol(),
   "  . ","\n       Fibo",
   "\n    ''.");//Txt
   PlaySound("Inform.wav");// 
   Print(Txt);//
   MessageBox(Txt,TxtExNm);//  
   return(0);//   , =0
     }// if(Err==4202)
   if(Err>0)Print("#41-ErrGetTIME1=",Err);// 
   Tm100p=Tm100;//    ( 100)
   Tm0=ObjectGet(NameM,OBJPROP_TIME2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#41-ErrGetTIME2=",Err);// 
   Tm0p=Tm0;//    ( 0)
   Pr100=ObjectGet(NameM,OBJPROP_PRICE1);//   ( 100)
   Err=GetLastError();if(Err>0)Print("#41-ErrGetPRICE1=",Err);// 
   Pr0=ObjectGet(NameM,OBJPROP_PRICE2);//   ( 0)
   Err=GetLastError();if(Err>0)Print("#41-ErrGetPRICE2=",Err);// 
//----4-2-      100------+
   if(VrtPnt==100)//
    {
   Tm0=Tm100;// Tm0
   if(ObjectSet(NameM,OBJPROP_TIME2,Tm0)!=true)// 2-  
   Print("#42-ErrSetTIME2=",GetLastError());// 
   Print(" ",NameM,"     100");//
    }// if(VrtPnt==100)
//----4-3-      0--------+
   if(VrtPnt==0)//
    {
   Tm100=Tm0;// Tm100
   if(ObjectSet(NameM,OBJPROP_TIME1,Tm100)!=true)// 1-  
   Print("#43-ErrSetTIME1=",GetLastError());// 
   Print(" ",NameM,"     0");//
    }// if(VrtPnt==0)
//----4-4-  100    --------------------+
   if(MvPnt100!=0)//
    {
   Shift=iBarShift(Symbol(),0,Tm100,false);//   
   if(Shift<MvPnt100)
     {
   Print(" 100  ",NameM,"     ",Shift,
   " (),   ",MvPnt100,".   ...");//
   MvPnt100=Shift;// MvPnt0
     }// if(Shift<MvPnt100)
   Tm100=iTime(NULL,0,Shift-MvPnt100);//Tm100
   if(ObjectSet(NameM,OBJPROP_TIME1,Tm100)!=true)//    100
   Print("#44-ErrSetTIME1=",GetLastError());// 
   Print(" 100  ",NameM,"   ",MvPnt100," ()");//
    }// if(MvPnt100!=0)
//----4-5-  0    ----------------------+
   if(MvPnt0!=0)//
    {
   Shift=iBarShift(Symbol(),0,Tm0,false);//   
   if(Shift<MvPnt0)//
     {
   Print(" 0  ",NameM,"     ",Shift,
   " (),   ",MvPnt0,".   ...");//
   MvPnt0=Shift;// MvPnt0
     }// if(Shift<MvPnt0)
   Tm0=iTime(NULL,0,Shift-MvPnt0);//Tm0
   if(ObjectSet(NameM,OBJPROP_TIME2,Tm0)!=true)//    0
   Print("#45-ErrSetTIME2=",GetLastError());// 
   Print(" 0  ",NameM,"   ",MvPnt0," ()");//
    }// if(MvPnt0!=0)    
//----4-6-    NmLn----------------+
   if(VrtPnt==100 || VrtPnt==0 || MvPnt100!=0 || MvPnt0!=0)//
    {
   for(i=0;i<ObjT;i++)//   
     {
   Name=ObjectName(i);//  i
   if(StringSubstr(Name,0,7)=="LevLine" &&//  LevLine
   StringSubstr(Name,14,10)==NameM)//   Fibo
      {
   Txt=StringSubstr(ObjectName(i),8,5);//Txt
   LevLnS=NormalizeDouble(StrToDouble(Txt),3);//  
   TmLnS=ObjectGet(ObjectName(i),OBJPROP_TIME1);//   
   TmLn1=Tm100+(Tm0-Tm100)*(1-LevLnS);//  TmLn1
   if((Txt=="0.000" || Txt=="1.000") && (TmLnS<TmLn1))z=0;//z- 
   else
       {
   if(ObjectSet(ObjectName(i),OBJPROP_TIME1,TmLn1)!=true)//  
   Print("#46-ErrSetOBJPROP_TIME1=",GetLastError());// 
       }// if(Txt=="0.000" || Txt=="1.000")
      }// if(StringSubstr(ObjectName(i),0,7)=="LevLine")
     }// for(i=0;i<ObjT;i++)     
    }// if(VrtPnt==100 || VrtPnt==0 || MvPnt100!=0 || MvPnt0!=0)    
//----4-7-     -----------+
   if(SvFstP==1 || SvFstP==2 || SvFstP==12)//
   {
   Txt=ObjectDescription(NameM);// 
   if(Txt=="")Txt=" ";// 
   Print("   ",NameM,": ",Txt);//
   if(SvFstP==1)Txt=StringConcatenate("T1=",TimeToStr(Tm100p,TIME_DATE|TIME_MINUTES),
   " T2=",TimeToStr(Tm0p,TIME_DATE|TIME_MINUTES));//Txt
   if(SvFstP==2)Txt=StringConcatenate("P1=",Pr100," P2=",Pr0);//Txt
   if(SvFstP==12)Txt=StringConcatenate("T1=",TimeToStr(Tm100p,TIME_DATE|TIME_MINUTES),
   " T2=",TimeToStr(Tm0p,TIME_DATE|TIME_MINUTES)," P1=",Pr100," P2=",Pr0);//Txt
   if(ObjectSetText(NameM,Txt,10,"Arial",CLR_NONE)!=true)//  
   Print("#47-ErrSetText=",GetLastError());// 
   Print("   ",NameM,": ",Txt);//
   }// if(SvFstP==1 || SvFstP==2 || SvFstP==12)
//----4-8-   ------------------+
   if(AddLev!=0)//     
   {
//----4-8-1-- ...--------------------------------------+
    for(i=0;i<32;i++)// 
    {
   if(AddLev==ObjectGet(NameM,OBJPROP_FIRSTLEVEL+i))//    
     {
   Err=GetLastError();if(Err>0)Print("#481-ObjectGet=",GetLastError());// 
   Print("  ",AddLev,"   ",NameM,
   "  , ..      ",i+1);//
   AddLev=0;//     
   break;//   for
     }// if(AddLev==ObjectGet(NameM,OBJPROP_FIRSTLEVEL+i))   
   Txt=ObjectGetFiboDescription(NameM,i);//    ,  32
   if(GetLastError()!=0) break;//   for
    }// for(i=0;i<32;i++)
//----4-8-2-  ----------------------------------+
   if(ObjectSet(NameM,OBJPROP_FIBOLEVELS,i+1)!=true)//   Fibo
   Print("#482-ErrFIBOLEVELS=",GetLastError());// 
   if(ObjectSet(NameM,OBJPROP_FIRSTLEVEL+i,AddLev)!=true)// i-  Fibo
   Print("#482-ErrFIRSTLEVEL+i=",GetLastError());// 
   else Txt=DoubleToStr(AddLev*100,1);//Txt
   if(ObjectSetFiboDescription(NameM,i,Txt)!=true)//   Fibo
   Print("#482-ErrSetFiboDescription=",GetLastError());// 
   else
    {
   Txt=ObjectGetFiboDescription(NameM,i);//   Fibo
   Print("  ",NameM,"    ",i+1,",  ~ ",Txt);//
    }// else
   }// if(AddLev!=0)
//----4-9-    ------------------------+
   if(LevLn!=10)//    10
   {
   NmLn=StringConcatenate("LevLine-",DoubleToStr(LevLn,3)," ",NameM);// 
   TmLn1=Tm100+(Tm0-Tm100)*(1-LevLn);//    1  NmLn
   TmLn2=iTime(NULL,PERIOD_D1,0)+86400;//    +
   PrLevLn=NormalizeDouble(Pr0+(Pr100-Pr0)*LevLn,Digits);//    LevLn
   ObjectCreate(NmLn,OBJ_TREND,0,TmLn1,PrLevLn,TmLn2,PrLevLn);// NmLn
   Err=GetLastError();// 
   if(Err==4200)// c    
     {
   if(ObjectDelete(NmLn)!=true)//  NmLn
   Print("#49-ErrObjectDelete=",GetLastError());// 
   if(ObjectCreate(NmLn,OBJ_TREND,0,TmLn1,PrLevLn,TmLn2,PrLevLn)!=true)// NmLn
   Print("#49-ErrObjectCreate=",GetLastError());// 
     }// if(Err==4200)
   else if(Err>0 && Err!=4066)Print("#49-ErrObjectCreateLevLine=",Err);// 
   if(ObjectSet(NmLn,OBJPROP_RAY,0)!=true)//    NmLn=0
   Print("#49-ErrSetRAY=",GetLastError());// 
   if(ObjectSet(NmLn,OBJPROP_STYLE,STYLE_DASH)!=true)// 
   Print("#49-ErrObjectSetSTYLE=",GetLastError());//    
   Clr=ObjectGet(NameM,OBJPROP_COLOR);//  
   Err=GetLastError();if(Err>0)Print("#39-ObjectGetCOLOR=",Err);// 
   if(ObjectSet(NmLn,OBJPROP_COLOR,Clr)!=true)// 
   Print("#49-ErrSetCOLOR=",GetLastError());//    
   Txt=StringConcatenate(" ",LevLn*100,"%, =",DoubleToStr(PrLevLn,Digits),
   ", ( : ",DoubleToStr(Pr100,Digits),"~",DoubleToStr(Pr0,Digits),")");//Txt
   if(ObjectSetText(NmLn,Txt,10,"Arial",CLR_NONE)!=true)//  
   Print("#49-ErrSetText=",GetLastError());//    
   Print("  ",NameM," ( : ",Pr100,"~",Pr0,
   ")   /   ",LevLn*100,
   "%, (=",PrLevLn,")");//
   }// if(LevLn!=10)
//----4-10-  ---------------------------------+
    if(SortLev==true)// 
    {
   for(n=0;n<32;n++)
     {
   MnL[n]=ObjectGet(NameM,OBJPROP_FIRSTLEVEL+n);//   Fibo[n]
   if(GetLastError()!=0) break;//    
   CntL++;// 
     }// for(n=0;n<32;n++)
   MnL[n]=ArraySort(MnL,CntL,0,MODE_ASCEND);// 
//----
   for(n=0;n<CntL;n++)
     {
   if(ObjectSet(NameM,OBJPROP_FIRSTLEVEL+n,MnL[n])!=true)//   Fibo[n]
   Print("#410-ErrSetFIRSTLEVEL+n=",GetLastError());// 
   Txt=DoubleToStr(MnL[n]*100,1);//Txt
   if(ObjectSetFiboDescription(NameM,n,Txt)!=true)//   Fibo
   Print("#410-ErrSetFiboDescription=",GetLastError());// 
     }// for(n=0;n<32;n++)
    }// if(SortLev==true)
//----4-11-/  ----------------------------+
   if(ShPr==1 || ShPr==0)//
    {
   for(n=0;n<32;n++)
     {
   MnL[n]=ObjectGet(NameM,OBJPROP_FIRSTLEVEL+n);//   Fibo[n]
   if(GetLastError()!=0) break;//    
   PrN=NormalizeDouble(Pr0+(Pr100-Pr0)*MnL[n],Digits);//  
   if(ShPr==0)//
   Txt=DoubleToStr(MnL[n]*100,1);//Txt
   if(ShPr==1)//
   Txt=StringConcatenate(DoubleToStr(PrN,Digits),"~",DoubleToStr(MnL[n]*100,1));//Txt
   if(ObjectSetFiboDescription(NameM,n,Txt)!=true)//   Fibo
   Print("#411-ErrSetFiboDescription=",GetLastError());// 
     }// for(n=0;n<32;n++)
   if(ShPr==1)Print("       ",NameM);//
   if(ShPr==0)Print("      ",NameM," ");//
    }// if(ShPri==true)
//====5========================================================+
   WindowRedraw();//   
   Sleep(5);// 
   Print("   ",NameM,
   ": Tm100=",TimeToStr(Tm100,TIME_DATE|TIME_MINUTES)," Pr100=",Pr100,
   " Tm0=",TimeToStr(Tm0,TIME_DATE|TIME_MINUTES)," Pr0=",Pr0);//
   Txt1=StringConcatenate(" ",TxtExNm,"    ",Symbol(),
   "  ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));//Txt1
   Txt2=("\n    .");//Txt2
   Txt=Txt1+Txt2;//Txt
   PlaySound("Inform.wav");// 
   Print(Txt1,",   ,  - ",
   GetTickCount()-StartMoment,".");//
   MessageBox(Txt,TxtExNm);//
   }// if(CntFb==1)
   return(0);//   , =0
  }
//+------------------------------------------------------------------+